> ## Documentation Index
> Fetch the complete documentation index at: https://goldrush.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# debug_traceTransaction on Ethereum

> debug_traceTransaction returns an opcode-level execution trace for a mined transaction on Ethereum, via GoldRush JSON-RPC.

> [card] 0.015 credits per call

`debug_traceTransaction` on **Ethereum**: Returns an opcode-level execution trace for a mined transaction.

> [!NOTE]
>
> `debug_traceTransaction` requires archive depth. See the [debug & trace matrix](https://goldrush.dev/docs/goldrush-json-rpc/debug-trace.md) for Ethereum archive coverage.

## Endpoint

```
https://rpc.goldrushdata.com/v1/eth-mainnet
```

Authenticate with `Authorization: Bearer <GOLDRUSH_API_KEY>`. See [authentication](https://goldrush.dev/docs/goldrush-json-rpc/authentication.md).

## Parameters

| Name | Type | Required | Description | Example |
| - | - | - | - | - |
| `transactionHash` | `DATA, 32 bytes` | yes | Transaction hash. | `"0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b"` |
| `options` | `Object` | no | `{tracer?, tracerConfig?, timeout?}`. Common tracers: `callTracer`, `prestateTracer`, `4byteTracer`. | `{"tracer":"callTracer"}` |

## Returns

`Object`: Tracer-specific output. With `callTracer`, the call graph rooted at the transaction's `from`/`to`.

```json theme={null}
{"type":"CALL","from":"0x...","to":"0x...","value":"0x0","gas":"0x5208","gasUsed":"0x5208","input":"0x..."}
```

## Examples

```bash curl theme={null}
curl https://rpc.goldrushdata.com/v1/eth-mainnet \
  -H "Authorization: Bearer $GOLDRUSH_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "jsonrpc": "2.0",
    "id": 1,
    "method": "debug_traceTransaction",
    "params": ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", {"tracer":"callTracer"}]
  }'
```

```typescript ethers v6 theme={null}
import { ethers } from "ethers";

const url = "https://rpc.goldrushdata.com/v1/eth-mainnet";
const fetchReq = new ethers.FetchRequest(url);
fetchReq.setHeader("Authorization", `Bearer ${process.env.GOLDRUSH_API_KEY}`);

const provider = new ethers.JsonRpcProvider(fetchReq);
const result = await provider.send("debug_traceTransaction", ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", {"tracer":"callTracer"}]);
console.log(result);
```

```typescript viem theme={null}
import { createPublicClient, http } from "viem";

const client = createPublicClient({
  transport: http("https://rpc.goldrushdata.com/v1/eth-mainnet", {
    fetchOptions: {
      headers: {
        Authorization: `Bearer ${process.env.GOLDRUSH_API_KEY}`,
      },
    },
  }),
});

const result = await client.request({
  method: "debug_traceTransaction",
  params: ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", {"tracer":"callTracer"}],
});
console.log(result);
```

```javascript web3.js theme={null}
import { Web3 } from "web3";

const provider = new Web3.providers.HttpProvider(
  "https://rpc.goldrushdata.com/v1/eth-mainnet",
  {
    headers: [
      { name: "Authorization", value: `Bearer ${process.env.GOLDRUSH_API_KEY}` },
    ],
  }
);
const web3 = new Web3(provider);

const result = await web3.currentProvider.request({
  method: "debug_traceTransaction",
  params: ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", {"tracer":"callTracer"}],
});
console.log(result);
```

```python web3.py theme={null}
from os import environ
from web3 import Web3

w3 = Web3(Web3.HTTPProvider(
    "https://rpc.goldrushdata.com/v1/eth-mainnet",
    request_kwargs={
        "headers": {
            "Authorization": f"Bearer {environ['GOLDRUSH_API_KEY']}",
        },
    },
))
result = w3.manager.request_blocking("debug_traceTransaction", ["0x88df016429689c079f3b2f6ad39fa052532c56795b733da78a91ebe6a713944b", {"tracer":"callTracer"}])
print(result)
```

## Errors

| Code | Message |
| - | - |
| `-32000` | Transaction not found, or trace failed. |

Plus standard JSON-RPC errors: `-32600` invalid request, `-32601` method not found, `-32602` invalid params.

## Related Debug and trace methods on Ethereum

* [`debug_traceCall` on Ethereum](https://goldrush.dev/docs/api-reference/json-rpc/ethereum/debug-tracecall)
* [`debug_traceBlockByHash` on Ethereum](https://goldrush.dev/docs/api-reference/json-rpc/ethereum/debug-traceblockbyhash)
* [`debug_traceBlockByNumber` on Ethereum](https://goldrush.dev/docs/api-reference/json-rpc/ethereum/debug-traceblockbynumber)
* [`trace_transaction` on Ethereum](https://goldrush.dev/docs/api-reference/json-rpc/ethereum/trace-transaction)
* [`trace_block` on Ethereum](https://goldrush.dev/docs/api-reference/json-rpc/ethereum/trace-block)

## Also available on

* [`debug_traceTransaction` on Polygon](https://goldrush.dev/docs/api-reference/json-rpc/polygon/debug-tracetransaction)
* [`debug_traceTransaction` on BNB Smart Chain (BSC)](https://goldrush.dev/docs/api-reference/json-rpc/bsc/debug-tracetransaction)
* [`debug_traceTransaction` on Arbitrum](https://goldrush.dev/docs/api-reference/json-rpc/arbitrum/debug-tracetransaction)
* [`debug_traceTransaction` on Base](https://goldrush.dev/docs/api-reference/json-rpc/base/debug-tracetransaction)
* [`debug_traceTransaction` on HyperEVM](https://goldrush.dev/docs/api-reference/json-rpc/hyperevm/debug-tracetransaction)
* [`debug_traceTransaction` on MegaETH](https://goldrush.dev/docs/api-reference/json-rpc/megaeth/debug-tracetransaction)
* [`debug_traceTransaction` on Monad](https://goldrush.dev/docs/api-reference/json-rpc/monad/debug-tracetransaction)
* [`debug_traceTransaction` on Tempo](https://goldrush.dev/docs/api-reference/json-rpc/tempo/debug-tracetransaction)
* [`debug_traceTransaction` on Robinhood Chain](https://goldrush.dev/docs/api-reference/json-rpc/robinhood/debug-tracetransaction)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.